/**
 * License Agreement.
 *
 *  JBoss RichFaces - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */
package org.richfaces.realworld.manager;

import java.io.Serializable;
import java.util.List;

import org.jboss.seam.ScopeType;
import org.jboss.seam.annotations.In;
import org.jboss.seam.annotations.Name;
import org.jboss.seam.annotations.Out;
import org.jboss.seam.annotations.Scope;
import org.richfaces.realworld.domain.Album;
import org.richfaces.realworld.domain.Image;
import org.richfaces.realworld.domain.User;
import org.richfaces.realworld.service.IUserAction;

@Name("userManager")
@Scope(ScopeType.CONVERSATION)
public class UserManager implements Serializable{
	
	@In("#{messages['addedtofriends']}") private String ADDED_TO_FRIENDS_MESSAGE_THEME;
	@In("#{messages['addedtofriendsby']}") private String ADDED_TO_FRIENDS_MESSAGE;
	@In("#{messages['removedfromfriends']}") private String REMOVED_FROM_FRIENDS_MESSAGE_THEME;
	@In("#{messages['removedfromfriendsby']}") private String YOU_ARE_WERE_REMOVED_FROM_FRIENDS_MESSAGE;
	@In("#{messages['friend_error']}")

	private static final long serialVersionUID = 6027103521084558931L;
	
	@In
	private User user;
	
	@In(create=true, required=true)
	private IUserAction userAction;
	
	public void addToFavoriteAlbums(Album album){
		userAction.addFavoriteAlbum(album);
	}
	
	public void removeFromFavoriteAlbums(Album album){
		userAction.removeFromFavoriteAlbums(user, album);
	}
	
	public void addToFavoriteImages(Image image){
		userAction.addFavoriteImage(image);
	}
	
	public void removeFromFavoriteImages(Image image){
		userAction.removeFromFavoriteImages(user, image);
	}

	public List<Album> getRootAlbums(User user2) {
		return userAction.getRootAlbums(user2);
	}
}
